Unit ec01r_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, FTF1C_p;

procedure ec01r(N :Integer; DT :Real; var A :Array of Real;
                var Y :Array of Real; P :Real; EPS :Real; L :Integer;
                var H :Array of Real; var X :Array of Real;
                var Z :Array of Real);

implementation

procedure ec01r(N :Integer; DT :Real; var A :Array of Real;
                var Y :Array of Real; P :Real; EPS :Real; L :Integer;
                var H :Array of Real; var X :Array of Real;
                var Z :Array of Real);
var
I,N1,N2,N3,K :Integer;
Q,B,C,D,S,R1,R2,R3,R4,R5,E,DW,P1,V,W,R,ALP,S1,S2 :Real;
const
SYS003 :Real = 6.2831853071795864769252867665590;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,_20;
begin
N1 := Trunc( N/2 );
case L of
 1: goto _1;
 2: goto _7;
 3: goto _4;
end;
_1:
for I:=1 to N do
 begin
_2:
  X[I-1] := 0.0;
 end;
Q := 1.0;
FTF1C(A,X,N,1,1,Q);
for I:=2 to N1 do
 begin
  N2 := N1+I;
_3:
  A[N2-1] := X[I-1];
 end;
_4:
for I:=1 to N do
 begin
_5:
  X[I-1] := 0.0;
 end;
Q := 1.0;
FTF1C(Y,X,N,1,1,Q);
for I:=2 to N1 do
 begin
  N2 := N1+I;
_6:
  Y[N2-1] := X[I-1];
 end;
_7:
B := 1.0/N;
C := 1.0/DT;
D := DT*DT;
S := 0.0;
for I:=2 to N1 do
 begin
  N2 := N1+I;
  R1 := Y[I-1];
  R2 := Y[N2-1];
_8:
  S := S+R1*R1+R2*R2;
 end;
N3 := Trunc( N/2+1 );
S := (S*2+Y[0]*Y[0]+Y[N3-1]*Y[N3-1])*DT*B;
S := Sqrt(S);
E := 1.0/(EPS*S);
DW := SYS003*B*C;
P1 := 2*P;
V := 0.0;
K := 0;
_9:
Q := V*D;
S1 := 0.0;
S2 := 0.0;
for I:=2 to N1 do
 begin
  N2 := N1+I;
  R1 := A[I-1];
  R2 := A[N2-1];
  R1 := R1*R1+R2*R2;
  R2 := Y[I-1];
  R3 := Y[N2-1];
  R2 := R2*R2+R3*R3;
  W := DW*(I-1);
  R := Power(W,P1);
  R3 := 1.0/(Q*R1+R);
  R2 := R2*(R*B)*R*R3*R3;
  S1 := S1+R2;
  R1 := R2*R1*R3;
_10:
  S2 := S2+R1;
 end;
R := Power(DW*N1,P1);
R3 := 1.0/(Q*A[N3-1]*A[N3-1]+R);
R2 := Y[N3-1]*Y[N3-1]*(R*B)*R*R3*R3;
R4 := 0.0;
if ( P = 0. ) 
 then R4 := 1./(Q*A[0]*A[0]+1.0);
R5 := Y[0]*Y[0]*B*R4*R4;
S1 := Sqrt((S1*2+R5+R2)*DT);
R1 := S1*E;
if ( R1-1.001 ) < 0
 then goto _11
 else if ( R1-1.001 ) > 0
       then goto _14
       else goto _11;
_11:
if ( V ) < 0
 then goto _12
 else if ( V ) > 0
       then goto _16
       else goto _12;
_12:
R4 := Y[0]*B*C/A[0];
if ( P = 0. ) 
 then R4 := 0.0;
for I:=1 to N do
 begin
_13:
  X[I-1] := R4;
 end;
H[0] := Sqrt(S*S-Y[0]*Y[0]*DT*B);
if ( P = 0. ) 
 then H[0] := S;
H[1] := 0.0;
H[2] := H[0];
H[3] := 0.0;
H[4] := 1.E+18;
H[5] := 0.0;
H[6] := H[0]/S;
goto _20;
_14:
if ( P = 0. ) 
 then R5 := R5*A[0]*A[0]*R4;
if ( P > 0. ) 
 then R5 := 0.0;
R2 := R2*A[N3-1]*A[N3-1]*R3;
R4 := 1.0/S1;
S2 := -(S2*2.0*R4+R5*R4+R2*R4)*(D*DT);
if ( S2 = 0. ) 
 then ALP := 0.0;
if ( S2 = 0. ) 
 then goto _15;
S2 := S1/S2*(1.0-R1);
V := V+S2;
K := K+1;
ALP := 1.0/V;
if ( ALP ) < 0
 then goto _15
 else if ( ALP ) > 0
       then goto _9
       else goto _15;
_15:
S1 := 0.0;
_16:
H[0] := S1;
H[4] := ALP;
H[5] := K;
H[6] := H[0]/S;
Q := ALP*C*C;
S1 := 0.0;
S2 := 0.0;
for I:=2 to N1 do
 begin
  N2 := N1+I;
  R1 := A[I-1];
  R2 := A[N2-1];
  R3 := Y[I-1];
  R4 := Y[N2-1];
  W := DW*(I-1);
  R := Power(W,P1);
  R5 := 1.0/(R1*R1+R2*R2+Q*R);
  E := ((R1*R3+R2*R4)*C)*R5;
  R2 := ((R1*R4-R2*R3)*C)*R5;
  X[I-1] := E;
  Z[I-1] := R2;
  R3 := (R*B)*(E*E+R2*R2);
  S1 := S1+R3;
  R4 := W*((ALP*R5)*R)*(ALP*R5)*R3;
_17:
  S2 := S2+R4;
 end;
R3 := 0.0;
if ( P = 0. ) 
 then R3 := 1.0;
X[0] := A[0]*Y[0]*C/(A[0]*A[0]+Q*R3);
R := Power(DW*N1,P1);
R5 := 1.0/(A[N3-1]*A[N3-1]+Q*R);
X[N3-1] := (A[N3-1]*Y[N3-1]*C)*R5;
S1 := (S1*2.0+(R3*B)*X[0]*X[0]+(R*B)*X[N3-1]*X[N3-1])*DT;
H[1] := Sqrt(S1);
H[2] := Sqrt(H[0]*H[0]+ALP*S1);
R5 := ((ALP*R5)*R)*X[N3-1];
R4 := (DW/2.0*R5)*R5;
H[3] := Sqrt((S2*2+R4)*C)*C;
Z[0] := 0.0;
Z[N3-1] := 0.0;
N3 := N+2;
for I:=2 to N1 do
 begin
  N2 := N3-I;
  X[N2-1] := X[I-1];
_18:
  Z[N2-1] := -Z[I-1];
 end;
Q := -1.0;
FTF1C(X,Z,N,1,1,Q);
for I:=1 to N1 do
 begin
  R := X[I-1]*B;
  N2 := N1+I;
  X[I-1] := X[N2-1]*B;
_19:
  X[N2-1] := R;
 end;
_20:
end;

end.
